


#include <stm32f10x_lib.h>

#include "SPI.h"
#include "Graphique.h"
#include "Utilitaires.h"
#include "Platine.h"
#include "Images.h"



int main(void)
{
	int k = 0;
	int u = 0;



	RCC->APB2ENR |= (1 << 2);	/* Activation de l'horloge du port A. */
	

	
	InitSPI1();
	InitITSPI1();



	InitialiserModuleGraphique();



   	EffacerAfficheurGraphique(0);



	Delai(100000);



	PositionnerCurseurXYGraphique(1, 1);
	AfficherLesBlocs();

	Delai(100000);

	EffacerAfficheurGraphique(0);
	PositionnerCurseurXYGraphique(1, 1);
	AfficherLesPages();

	Delai(100000);

   	EffacerAfficheurGraphique(0);

	TracerPointXYGraphique(7, 16, 1);
	TracerRectangleGraphique(28, 15, 9, 29, 1);
	TracerCadreGraphique(9, 39, 68, 19, 1);

	Delai(100000);

	for(k = 0; k < 2; k++)
	{
		EffacerAfficheurGraphique(1 - k);
	
		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope", k);
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_BARRE | k));
	
		Delai(100000);
	
		EffacerAfficheurGraphique(1 - k);
	
		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_LARGEUR_DOUBLE | k));
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_BARRE | k));
	
		Delai(100000);
	
		EffacerAfficheurGraphique(1 - k);
	
		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_HAUTEUR_DOUBLE | k));
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_BARRE | k));
	
		Delai(100000);
	
		EffacerAfficheurGraphique(1 - k);
	
		PositionnerCurseurXYGraphique(3, 1);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | k));
	
		PositionnerCurseurXYGraphique(3, 4);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_SOULIGNE | k));
	
		PositionnerCurseurXYGraphique(3, 7);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_BARRE | k));
	
		Delai(100000);
	}



	EffacerAfficheurGraphique(0);



	while(1)
	{
		/* Dbut de l'affichage du texte simple */
		ChangerEtatLED(0);
		Delai(100000);
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Coucou !", ATTRIBUT_POSITIF);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte simple", ATTRIBUT_POSITIF);
		Delai(100000);
		/* Fin de l'affichage du texte simple */

		/* Dbut de l'affichage du texte avec inversion */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Salut Ginette !", ATTRIBUT_NORMAL);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte avec inversion", ATTRIBUT_POSITIF);
		Delai(100000);
		/* Fin de l'affichage du texte avec inversion */

		/* Dbut de l'affichage du texte de taille double */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Nyctalope", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte double", ATTRIBUT_POSITIF);
		Delai(100000);
		/*Fin de l'affichage du texte de taille double*/

		/*Dbut de l'affichage du texte de taille double, avec inversion*/
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("0356209917", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_NORMAL));
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Texte double, inv.", ATTRIBUT_POSITIF);
		Delai(100000);
		/*Fin de l'affichage du texte de taille double*/

		/*Dbut de l'affichage du (faux) texte long*/
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(1, 1);
		AfficherTexteGraphique("Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam volutpat tortor sed eros auctor id fringilla ligula eleifend. Integer faucibus est qui", ATTRIBUT_POSITIF);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("(Faux) Texte long", ATTRIBUT_POSITIF);
		Delai(300000);
		/* Fin de l'affichage du (faux) texte long */

		/* Dbut de l'affichage de l'ensemble des symboles affichables */
		EffacerAfficheurGraphique(0);
		for(k = 0x20; k < 0x83; k++)
		{
			AfficherCaractereGraphique(k, ATTRIBUT_POSITIF);
		}
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Symboles affichables", ATTRIBUT_POSITIF);
		Delai(300000);
		
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Comptage", ATTRIBUT_POSITIF);
		for(u = (-100); u <= 180; u++)
		{
			PositionnerCurseurXYGraphique(16, 3);
			ConvertirAfficherGraphique(u, 10, (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			AfficherTexteGraphique("  ", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(10);
		}
		Delai(300000);
		/* Fin de l'affichage de l'ensemble des symboles affichables */

		/* Dbut de l'affichage de la barre de chargement */
		/* Dbut du dessin de la barre de chargement, vide */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Barre de chargement", ATTRIBUT_POSITIF);
		PositionnerCurseurXYGraphique(12, 2);
		EnvoyerDonneeGraphique(0xFF);
		EnvoyerDonneeGraphique(0x81);
		for(u = 0; u <= 100; u++)
		{
			EnvoyerDonneeGraphique(0x81);
		}
		EnvoyerDonneeGraphique(0x81);
		EnvoyerDonneeGraphique(0xFF);

		/* Fin du dessin de la barre de chargement, vide */

		/* Dbut du remplissage de la barre de chargement, et de l'augmentation du pourcentage de son remplissage */
		for(u = 0; u <= 100; u++)
		{
			PositionnerCurseurXYGraphique((14 + u), 2);
			EnvoyerDonneeGraphique(0xBD);
		
			PositionnerCurseurXYGraphique(43, 4);
			ConvertirAfficherGraphique(u, 10, (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			AfficherTexteGraphique("% ", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(3000);
		}
		/* Fin du remplissage de la barre de chargement, et de l'augmentation du pourcentage de son remplissage*/

		Delai(300000);

		/* Fin de l'affichage de la barre de chargement */
		
		/* Dbut de l'affichage du  Trollface  */
		EffacerAfficheurGraphique(0);
		AfficherImageGraphique(Trollface, 1);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Image : Trollface !", ATTRIBUT_POSITIF);
		Delai(300000);
		/* Fin de l'affichage du  Trollface  */

		/* Dbut du changement de l'tat du rtroclairage de l'afficheur graphique */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Commande allumage", ATTRIBUT_POSITIF);
		for(u = 0; u <= 5; u++)
		{
			ChangerEtatRetroeclairage(0);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Nuit", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
			
			ChangerEtatRetroeclairage(1);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Jour", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
		}

		Delai(300000);
		/* Fin du changement de l'tat du rtroclairage de l'afficheur graphique */

		/* Dbut du changement de l'tat de la LED du module de l'afficheur graphique */
		EffacerAfficheurGraphique(0);
		PositionnerCurseurXYGraphique(2, 8);
		AfficherTexteGraphique("Commande LED", ATTRIBUT_POSITIF);
		for(u = 0; u <= 5; u++)
		{
			ChangerEtatLED(0);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Non", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
			
			ChangerEtatLED(1);
			
			PositionnerCurseurXYGraphique(15, 2);
			AfficherTexteGraphique("Oui", (ATTRIBUT_HAUTEUR_DOUBLE | ATTRIBUT_LARGEUR_DOUBLE | ATTRIBUT_POSITIF));
			Delai(30000);
		}

		Delai(300000);
		/* Fin du changement de l'tat de la LED du module de l'afficheur graphique */

		}
}



/*Fonction qui permet l'initialisation du microcontrleur STM32F100RB

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void SystemInit (void)
{
	RCC->CR |= 0x01;
	while((RCC->CR & ~(1 << 1)) == 0x00);
	RCC->CR |= (1 << 16);
	while((RCC->CR & ~(1 << 17)) == 0x00);
	
	RCC->CFGR |= (4 << 18);
	RCC->CFGR |= (1 << 16);
	
	RCC->CFGR |= 0x02;
	
	RCC->CR |= (1 << 24);
	while((RCC->CR & ~(1 << 24)) == 0x00);
	RCC->CFGR |= 0x02;
}


